------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2008-2010 Vadim Godunko <vgodunko@gmail.com>                 --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--    This file has been generated automatically. Please don't edit it.     --
------------------------------------------------------------------------------
with Qt4.Actions;
with Qt4.Layouts;
with Qt4.Styles;
with Qt_Ada.Internals.Object_Registry;
with Qt_Ada.Internals.Objects;
with Qt_Ada.Internals.Objects.Object_Utilities;
with System;

with Qt_Ada.Internals.Objects.Widget_Proxies;
pragma Warnings (Off, Qt_Ada.Internals.Objects.Widget_Proxies);
--  Elaboration of the proxy tagged type package register proxy object
--  constructor. Bindings must be able to create proxy object of the
--  corresponding tagged type for works properly.

package body Qt4.Widgets is

   function acceptDrops_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject)
       return Qt4.bool;
   pragma Import (C, acceptDrops_0_wrapper,
                     "__Qt4Ada_QWidget_acceptDrops_0_wrapper");

   procedure accessibleDescription_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Returns : not null access Qt4.Strings.Internals.QString);
   pragma Import (C, accessibleDescription_0_wrapper,
                     "__Qt4Ada_QWidget_accessibleDescription_0_wrapper");

   procedure accessibleName_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Returns : not null access Qt4.Strings.Internals.QString);
   pragma Import (C, accessibleName_0_wrapper,
                     "__Qt4Ada_QWidget_accessibleName_0_wrapper");

   procedure activateWindow_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject);
   pragma Import (C, activateWindow_0_wrapper,
                     "__Qt4Ada_QWidget_activateWindow_0_wrapper");

   procedure addAction_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Action : not null access Qt_Ada.Internals.Objects.QObject);
   pragma Import (C, addAction_0_wrapper,
                     "__Qt4Ada_QWidget_addAction_0_wrapper");

   procedure adjustSize_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject);
   pragma Import (C, adjustSize_0_wrapper,
                     "__Qt4Ada_QWidget_adjustSize_0_wrapper");

   function autoFillBackground_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject)
       return Qt4.bool;
   pragma Import (C, autoFillBackground_0_wrapper,
                     "__Qt4Ada_QWidget_autoFillBackground_0_wrapper");

   procedure baseSize_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Returns : not null access Qt4.Sizes.Internals.QSize);
   pragma Import (C, baseSize_0_wrapper,
                     "__Qt4Ada_QWidget_baseSize_0_wrapper");

   procedure childAt_1_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     X : Qt4.Q_Integer;
     Y : Qt4.Q_Integer);
   pragma Import (C, childAt_1_wrapper,
                     "__Qt4Ada_QWidget_childAt_1_wrapper");

   procedure childAt_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     P : not null access constant Qt4.Points.Internals.QPoint);
   pragma Import (C, childAt_0_wrapper,
                     "__Qt4Ada_QWidget_childAt_0_wrapper");

   procedure childrenRect_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Returns : not null access Qt4.Rects.Internals.QRect);
   pragma Import (C, childrenRect_0_wrapper,
                     "__Qt4Ada_QWidget_childrenRect_0_wrapper");

   procedure childrenRegion_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Returns : not null access Qt4.Regions.Internals.QRegion);
   pragma Import (C, childrenRegion_0_wrapper,
                     "__Qt4Ada_QWidget_childrenRegion_0_wrapper");

   procedure clearFocus_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject);
   pragma Import (C, clearFocus_0_wrapper,
                     "__Qt4Ada_QWidget_clearFocus_0_wrapper");

   procedure clearMask_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject);
   pragma Import (C, clearMask_0_wrapper,
                     "__Qt4Ada_QWidget_clearMask_0_wrapper");

   procedure contentsRect_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Returns : not null access Qt4.Rects.Internals.QRect);
   pragma Import (C, contentsRect_0_wrapper,
                     "__Qt4Ada_QWidget_contentsRect_0_wrapper");

   function contextMenuPolicy_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject)
       return Qt4.Context_Menu_Policy;
   pragma Import (C, contextMenuPolicy_0_wrapper,
                     "__Qt4Ada_QWidget_contextMenuPolicy_0_wrapper");

   procedure cursor_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Returns : not null access Qt4.Cursors.Internals.QCursor);
   pragma Import (C, cursor_0_wrapper,
                     "__Qt4Ada_QWidget_cursor_0_wrapper");

   function effectiveWinId_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject)
       return Qt4.W_Id;
   pragma Import (C, effectiveWinId_0_wrapper,
                     "__Qt4Ada_QWidget_effectiveWinId_0_wrapper");

   procedure ensurePolished_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject);
   pragma Import (C, ensurePolished_0_wrapper,
                     "__Qt4Ada_QWidget_ensurePolished_0_wrapper");

   function focusPolicy_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject)
       return Qt4.Focus_Policy;
   pragma Import (C, focusPolicy_0_wrapper,
                     "__Qt4Ada_QWidget_focusPolicy_0_wrapper");

   function focusProxy_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject)
       return not null access Qt_Ada.Internals.Objects.QObject;
   pragma Import (C, focusProxy_0_wrapper,
                     "__Qt4Ada_QWidget_focusProxy_0_wrapper");

   function focusWidget_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject)
       return not null access Qt_Ada.Internals.Objects.QObject;
   pragma Import (C, focusWidget_0_wrapper,
                     "__Qt4Ada_QWidget_focusWidget_0_wrapper");

   procedure font_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Returns : not null access Qt4.Fonts.Internals.QFont);
   pragma Import (C, font_0_wrapper,
                     "__Qt4Ada_QWidget_font_0_wrapper");

   function fontInfo_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Storage : System.Address)
       return Qt4.Font_Infos.Internals.QFontInfo_Access;
   pragma Import (C, fontInfo_0_wrapper,
                     "__Qt4Ada_QWidget_fontInfo_0_wrapper");

   function fontMetrics_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Storage : System.Address)
       return Qt4.Font_Metrics.Internals.QFontMetrics_Access;
   pragma Import (C, fontMetrics_0_wrapper,
                     "__Qt4Ada_QWidget_fontMetrics_0_wrapper");

   procedure frameGeometry_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Returns : not null access Qt4.Rects.Internals.QRect);
   pragma Import (C, frameGeometry_0_wrapper,
                     "__Qt4Ada_QWidget_frameGeometry_0_wrapper");

   procedure frameSize_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Returns : not null access Qt4.Sizes.Internals.QSize);
   pragma Import (C, frameSize_0_wrapper,
                     "__Qt4Ada_QWidget_frameSize_0_wrapper");

   procedure grabKeyboard_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject);
   pragma Import (C, grabKeyboard_0_wrapper,
                     "__Qt4Ada_QWidget_grabKeyboard_0_wrapper");

   procedure grabMouse_1_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject);
   pragma Import (C, grabMouse_1_wrapper,
                     "__Qt4Ada_QWidget_grabMouse_1_wrapper");

   procedure grabMouse_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Cursor : not null access constant Qt4.Cursors.Internals.QCursor);
   pragma Import (C, grabMouse_0_wrapper,
                     "__Qt4Ada_QWidget_grabMouse_0_wrapper");

   function hasFocus_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject)
       return Qt4.bool;
   pragma Import (C, hasFocus_0_wrapper,
                     "__Qt4Ada_QWidget_hasFocus_0_wrapper");

   function hasMouseTracking_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject)
       return Qt4.bool;
   pragma Import (C, hasMouseTracking_0_wrapper,
                     "__Qt4Ada_QWidget_hasMouseTracking_0_wrapper");

   function height_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject)
       return Qt4.Q_Integer;
   pragma Import (C, height_0_wrapper,
                     "__Qt4Ada_QWidget_height_0_wrapper");

   procedure insertAction_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Before : access Qt_Ada.Internals.Objects.QObject;
     Action : not null access Qt_Ada.Internals.Objects.QObject);
   pragma Import (C, insertAction_0_wrapper,
                     "__Qt4Ada_QWidget_insertAction_0_wrapper");

   function isActiveWindow_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject)
       return Qt4.bool;
   pragma Import (C, isActiveWindow_0_wrapper,
                     "__Qt4Ada_QWidget_isActiveWindow_0_wrapper");

   function isAncestorOf_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Child : not null access constant Qt_Ada.Internals.Objects.QObject)
       return Qt4.bool;
   pragma Import (C, isAncestorOf_0_wrapper,
                     "__Qt4Ada_QWidget_isAncestorOf_0_wrapper");

   function isEnabled_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject)
       return Qt4.bool;
   pragma Import (C, isEnabled_0_wrapper,
                     "__Qt4Ada_QWidget_isEnabled_0_wrapper");

   function isEnabledTo_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Ancestor : not null access Qt_Ada.Internals.Objects.QObject)
       return Qt4.bool;
   pragma Import (C, isEnabledTo_0_wrapper,
                     "__Qt4Ada_QWidget_isEnabledTo_0_wrapper");

   function isFullScreen_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject)
       return Qt4.bool;
   pragma Import (C, isFullScreen_0_wrapper,
                     "__Qt4Ada_QWidget_isFullScreen_0_wrapper");

   function isHidden_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject)
       return Qt4.bool;
   pragma Import (C, isHidden_0_wrapper,
                     "__Qt4Ada_QWidget_isHidden_0_wrapper");

   function isMaximized_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject)
       return Qt4.bool;
   pragma Import (C, isMaximized_0_wrapper,
                     "__Qt4Ada_QWidget_isMaximized_0_wrapper");

   function isMinimized_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject)
       return Qt4.bool;
   pragma Import (C, isMinimized_0_wrapper,
                     "__Qt4Ada_QWidget_isMinimized_0_wrapper");

   function isModal_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject)
       return Qt4.bool;
   pragma Import (C, isModal_0_wrapper,
                     "__Qt4Ada_QWidget_isModal_0_wrapper");

   function isVisible_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject)
       return Qt4.bool;
   pragma Import (C, isVisible_0_wrapper,
                     "__Qt4Ada_QWidget_isVisible_0_wrapper");

   function isVisibleTo_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Ancestor : not null access Qt_Ada.Internals.Objects.QObject)
       return Qt4.bool;
   pragma Import (C, isVisibleTo_0_wrapper,
                     "__Qt4Ada_QWidget_isVisibleTo_0_wrapper");

   function isWindow_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject)
       return Qt4.bool;
   pragma Import (C, isWindow_0_wrapper,
                     "__Qt4Ada_QWidget_isWindow_0_wrapper");

   function isWindowModified_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject)
       return Qt4.bool;
   pragma Import (C, isWindowModified_0_wrapper,
                     "__Qt4Ada_QWidget_isWindowModified_0_wrapper");

   function layout_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject)
       return not null access Qt_Ada.Internals.Objects.QObject;
   pragma Import (C, layout_0_wrapper,
                     "__Qt4Ada_QWidget_layout_0_wrapper");

   procedure mapFrom_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Parent : not null access Qt_Ada.Internals.Objects.QObject;
     Pos : not null access constant Qt4.Points.Internals.QPoint;
     Returns : not null access Qt4.Points.Internals.QPoint);
   pragma Import (C, mapFrom_0_wrapper,
                     "__Qt4Ada_QWidget_mapFrom_0_wrapper");

   procedure mapFromGlobal_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Pos : not null access constant Qt4.Points.Internals.QPoint;
     Returns : not null access Qt4.Points.Internals.QPoint);
   pragma Import (C, mapFromGlobal_0_wrapper,
                     "__Qt4Ada_QWidget_mapFromGlobal_0_wrapper");

   procedure mapFromParent_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Pos : not null access constant Qt4.Points.Internals.QPoint;
     Returns : not null access Qt4.Points.Internals.QPoint);
   pragma Import (C, mapFromParent_0_wrapper,
                     "__Qt4Ada_QWidget_mapFromParent_0_wrapper");

   procedure mapTo_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Parent : not null access Qt_Ada.Internals.Objects.QObject;
     Pos : not null access constant Qt4.Points.Internals.QPoint;
     Returns : not null access Qt4.Points.Internals.QPoint);
   pragma Import (C, mapTo_0_wrapper,
                     "__Qt4Ada_QWidget_mapTo_0_wrapper");

   procedure mapToGlobal_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Pos : not null access constant Qt4.Points.Internals.QPoint;
     Returns : not null access Qt4.Points.Internals.QPoint);
   pragma Import (C, mapToGlobal_0_wrapper,
                     "__Qt4Ada_QWidget_mapToGlobal_0_wrapper");

   procedure mapToParent_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Pos : not null access constant Qt4.Points.Internals.QPoint;
     Returns : not null access Qt4.Points.Internals.QPoint);
   pragma Import (C, mapToParent_0_wrapper,
                     "__Qt4Ada_QWidget_mapToParent_0_wrapper");

   procedure mask_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Returns : not null access Qt4.Regions.Internals.QRegion);
   pragma Import (C, mask_0_wrapper,
                     "__Qt4Ada_QWidget_mask_0_wrapper");

   function maximumHeight_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject)
       return Qt4.Q_Integer;
   pragma Import (C, maximumHeight_0_wrapper,
                     "__Qt4Ada_QWidget_maximumHeight_0_wrapper");

   procedure maximumSize_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Returns : not null access Qt4.Sizes.Internals.QSize);
   pragma Import (C, maximumSize_0_wrapper,
                     "__Qt4Ada_QWidget_maximumSize_0_wrapper");

   function maximumWidth_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject)
       return Qt4.Q_Integer;
   pragma Import (C, maximumWidth_0_wrapper,
                     "__Qt4Ada_QWidget_maximumWidth_0_wrapper");

   function minimumHeight_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject)
       return Qt4.Q_Integer;
   pragma Import (C, minimumHeight_0_wrapper,
                     "__Qt4Ada_QWidget_minimumHeight_0_wrapper");

   procedure minimumSize_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Returns : not null access Qt4.Sizes.Internals.QSize);
   pragma Import (C, minimumSize_0_wrapper,
                     "__Qt4Ada_QWidget_minimumSize_0_wrapper");

   function minimumWidth_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject)
       return Qt4.Q_Integer;
   pragma Import (C, minimumWidth_0_wrapper,
                     "__Qt4Ada_QWidget_minimumWidth_0_wrapper");

   procedure move_1_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Pos : not null access constant Qt4.Points.Internals.QPoint);
   pragma Import (C, move_1_wrapper,
                     "__Qt4Ada_QWidget_move_1_wrapper");

   procedure move_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     X : Qt4.Q_Integer;
     Y : Qt4.Q_Integer);
   pragma Import (C, move_0_wrapper,
                     "__Qt4Ada_QWidget_move_0_wrapper");

   function nextInFocusChain_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject)
       return not null access Qt_Ada.Internals.Objects.QObject;
   pragma Import (C, nextInFocusChain_0_wrapper,
                     "__Qt4Ada_QWidget_nextInFocusChain_0_wrapper");

   procedure normalGeometry_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Returns : not null access Qt4.Rects.Internals.QRect);
   pragma Import (C, normalGeometry_0_wrapper,
                     "__Qt4Ada_QWidget_normalGeometry_0_wrapper");

   procedure palette_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Returns : out Qt4.Palettes.Thin.QPalette);
   pragma Import (C, palette_0_wrapper,
                     "__Qt4Ada_QWidget_palette_0_wrapper");

   function parentWidget_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject)
       return not null access Qt_Ada.Internals.Objects.QObject;
   pragma Import (C, parentWidget_0_wrapper,
                     "__Qt4Ada_QWidget_parentWidget_0_wrapper");

   procedure pos_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Returns : not null access Qt4.Points.Internals.QPoint);
   pragma Import (C, pos_0_wrapper,
                     "__Qt4Ada_QWidget_pos_0_wrapper");

   procedure rect_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Returns : not null access Qt4.Rects.Internals.QRect);
   pragma Import (C, rect_0_wrapper,
                     "__Qt4Ada_QWidget_rect_0_wrapper");

   procedure releaseKeyboard_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject);
   pragma Import (C, releaseKeyboard_0_wrapper,
                     "__Qt4Ada_QWidget_releaseKeyboard_0_wrapper");

   procedure releaseMouse_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject);
   pragma Import (C, releaseMouse_0_wrapper,
                     "__Qt4Ada_QWidget_releaseMouse_0_wrapper");

   procedure removeAction_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Action : not null access Qt_Ada.Internals.Objects.QObject);
   pragma Import (C, removeAction_0_wrapper,
                     "__Qt4Ada_QWidget_removeAction_0_wrapper");

   procedure repaint_3_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     X : Qt4.Q_Integer;
     Y : Qt4.Q_Integer;
     W : Qt4.Q_Integer;
     H : Qt4.Q_Integer);
   pragma Import (C, repaint_3_wrapper,
                     "__Qt4Ada_QWidget_repaint_3_wrapper");

   procedure repaint_2_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     R : not null access constant Qt4.Rects.Internals.QRect);
   pragma Import (C, repaint_2_wrapper,
                     "__Qt4Ada_QWidget_repaint_2_wrapper");

   procedure repaint_1_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Rng : not null access constant Qt4.Regions.Internals.QRegion);
   pragma Import (C, repaint_1_wrapper,
                     "__Qt4Ada_QWidget_repaint_1_wrapper");

   procedure resize_1_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Size : not null access constant Qt4.Sizes.Internals.QSize);
   pragma Import (C, resize_1_wrapper,
                     "__Qt4Ada_QWidget_resize_1_wrapper");

   procedure resize_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     W : Qt4.Q_Integer;
     H : Qt4.Q_Integer);
   pragma Import (C, resize_0_wrapper,
                     "__Qt4Ada_QWidget_resize_0_wrapper");

   procedure restoreGeometry_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Geometry : not null access constant Qt4.Byte_Arrays.Internals.QByteArray);
   pragma Import (C, restoreGeometry_0_wrapper,
                     "__Qt4Ada_QWidget_restoreGeometry_0_wrapper");

   procedure saveGeometry_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Returns : not null access Qt4.Byte_Arrays.Internals.QByteArray);
   pragma Import (C, saveGeometry_0_wrapper,
                     "__Qt4Ada_QWidget_saveGeometry_0_wrapper");

   procedure scroll_1_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Dx : Qt4.Q_Integer;
     Dy : Qt4.Q_Integer);
   pragma Import (C, scroll_1_wrapper,
                     "__Qt4Ada_QWidget_scroll_1_wrapper");

   procedure scroll_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Dx : Qt4.Q_Integer;
     Dy : Qt4.Q_Integer;
     R : not null access constant Qt4.Rects.Internals.QRect);
   pragma Import (C, scroll_0_wrapper,
                     "__Qt4Ada_QWidget_scroll_0_wrapper");

   procedure setAcceptDrops_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     On : Qt4.bool);
   pragma Import (C, setAcceptDrops_0_wrapper,
                     "__Qt4Ada_QWidget_setAcceptDrops_0_wrapper");

   procedure setAccessibleDescription_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Description : not null access constant Qt4.Strings.Internals.QString);
   pragma Import (C, setAccessibleDescription_0_wrapper,
                     "__Qt4Ada_QWidget_setAccessibleDescription_0_wrapper");

   procedure setAccessibleName_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Name : not null access constant Qt4.Strings.Internals.QString);
   pragma Import (C, setAccessibleName_0_wrapper,
                     "__Qt4Ada_QWidget_setAccessibleName_0_wrapper");

   procedure setAttribute_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Attribute : Qt4.Widget_Attribute;
     On : Qt4.bool);
   pragma Import (C, setAttribute_0_wrapper,
                     "__Qt4Ada_QWidget_setAttribute_0_wrapper");

   procedure setAutoFillBackground_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     On : Qt4.bool);
   pragma Import (C, setAutoFillBackground_0_wrapper,
                     "__Qt4Ada_QWidget_setAutoFillBackground_0_wrapper");

   procedure setBaseSize_1_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Size : not null access constant Qt4.Sizes.Internals.QSize);
   pragma Import (C, setBaseSize_1_wrapper,
                     "__Qt4Ada_QWidget_setBaseSize_1_wrapper");

   procedure setBaseSize_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Basew : Qt4.Q_Integer;
     Baseh : Qt4.Q_Integer);
   pragma Import (C, setBaseSize_0_wrapper,
                     "__Qt4Ada_QWidget_setBaseSize_0_wrapper");

   procedure setContentsMargins_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Left : Qt4.Q_Integer;
     Top : Qt4.Q_Integer;
     Right : Qt4.Q_Integer;
     Bottom : Qt4.Q_Integer);
   pragma Import (C, setContentsMargins_0_wrapper,
                     "__Qt4Ada_QWidget_setContentsMargins_0_wrapper");

   procedure setContextMenuPolicy_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Policy : Qt4.Context_Menu_Policy);
   pragma Import (C, setContextMenuPolicy_0_wrapper,
                     "__Qt4Ada_QWidget_setContextMenuPolicy_0_wrapper");

   procedure setCursor_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Cursor : not null access constant Qt4.Cursors.Internals.QCursor);
   pragma Import (C, setCursor_0_wrapper,
                     "__Qt4Ada_QWidget_setCursor_0_wrapper");

   procedure setFixedHeight_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     H : Qt4.Q_Integer);
   pragma Import (C, setFixedHeight_0_wrapper,
                     "__Qt4Ada_QWidget_setFixedHeight_0_wrapper");

   procedure setFixedSize_1_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Size : not null access constant Qt4.Sizes.Internals.QSize);
   pragma Import (C, setFixedSize_1_wrapper,
                     "__Qt4Ada_QWidget_setFixedSize_1_wrapper");

   procedure setFixedSize_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     W : Qt4.Q_Integer;
     H : Qt4.Q_Integer);
   pragma Import (C, setFixedSize_0_wrapper,
                     "__Qt4Ada_QWidget_setFixedSize_0_wrapper");

   procedure setFixedWidth_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     H : Qt4.Q_Integer);
   pragma Import (C, setFixedWidth_0_wrapper,
                     "__Qt4Ada_QWidget_setFixedWidth_0_wrapper");

   procedure setFocus_1_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Reason : Qt4.Focus_Reason);
   pragma Import (C, setFocus_1_wrapper,
                     "__Qt4Ada_QWidget_setFocus_1_wrapper");

   procedure setFocusPolicy_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Policy : Qt4.Focus_Policy);
   pragma Import (C, setFocusPolicy_0_wrapper,
                     "__Qt4Ada_QWidget_setFocusPolicy_0_wrapper");

   procedure setFocusProxy_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     W : not null access Qt_Ada.Internals.Objects.QObject);
   pragma Import (C, setFocusProxy_0_wrapper,
                     "__Qt4Ada_QWidget_setFocusProxy_0_wrapper");

   procedure setFont_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Font : not null access constant Qt4.Fonts.Internals.QFont);
   pragma Import (C, setFont_0_wrapper,
                     "__Qt4Ada_QWidget_setFont_0_wrapper");

   procedure setGeometry_1_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     R : not null access constant Qt4.Rects.Internals.QRect);
   pragma Import (C, setGeometry_1_wrapper,
                     "__Qt4Ada_QWidget_setGeometry_1_wrapper");

   procedure setGeometry_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     X : Qt4.Q_Integer;
     Y : Qt4.Q_Integer;
     W : Qt4.Q_Integer;
     H : Qt4.Q_Integer);
   pragma Import (C, setGeometry_0_wrapper,
                     "__Qt4Ada_QWidget_setGeometry_0_wrapper");

   procedure setLayout_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Layout : not null access Qt_Ada.Internals.Objects.QObject);
   pragma Import (C, setLayout_0_wrapper,
                     "__Qt4Ada_QWidget_setLayout_0_wrapper");

   procedure setMask_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Region : not null access constant Qt4.Regions.Internals.QRegion);
   pragma Import (C, setMask_0_wrapper,
                     "__Qt4Ada_QWidget_setMask_0_wrapper");

   procedure setMaximumHeight_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Maxh : Qt4.Q_Integer);
   pragma Import (C, setMaximumHeight_0_wrapper,
                     "__Qt4Ada_QWidget_setMaximumHeight_0_wrapper");

   procedure setMaximumSize_1_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Size : not null access constant Qt4.Sizes.Internals.QSize);
   pragma Import (C, setMaximumSize_1_wrapper,
                     "__Qt4Ada_QWidget_setMaximumSize_1_wrapper");

   procedure setMaximumSize_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Maxw : Qt4.Q_Integer;
     Maxh : Qt4.Q_Integer);
   pragma Import (C, setMaximumSize_0_wrapper,
                     "__Qt4Ada_QWidget_setMaximumSize_0_wrapper");

   procedure setMaximumWidth_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Maxw : Qt4.Q_Integer);
   pragma Import (C, setMaximumWidth_0_wrapper,
                     "__Qt4Ada_QWidget_setMaximumWidth_0_wrapper");

   procedure setMinimumHeight_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Minh : Qt4.Q_Integer);
   pragma Import (C, setMinimumHeight_0_wrapper,
                     "__Qt4Ada_QWidget_setMinimumHeight_0_wrapper");

   procedure setMinimumSize_1_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Size : not null access constant Qt4.Sizes.Internals.QSize);
   pragma Import (C, setMinimumSize_1_wrapper,
                     "__Qt4Ada_QWidget_setMinimumSize_1_wrapper");

   procedure setMinimumSize_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Minw : Qt4.Q_Integer;
     Minh : Qt4.Q_Integer);
   pragma Import (C, setMinimumSize_0_wrapper,
                     "__Qt4Ada_QWidget_setMinimumSize_0_wrapper");

   procedure setMinimumWidth_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Minw : Qt4.Q_Integer);
   pragma Import (C, setMinimumWidth_0_wrapper,
                     "__Qt4Ada_QWidget_setMinimumWidth_0_wrapper");

   procedure setMouseTracking_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Enable : Qt4.bool);
   pragma Import (C, setMouseTracking_0_wrapper,
                     "__Qt4Ada_QWidget_setMouseTracking_0_wrapper");

   procedure setPalette_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Palette : not null access constant Qt4.Palettes.Thin.QPalette);
   pragma Import (C, setPalette_0_wrapper,
                     "__Qt4Ada_QWidget_setPalette_0_wrapper");

   procedure setParent_1_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Parent : not null access Qt_Ada.Internals.Objects.QObject);
   pragma Import (C, setParent_1_wrapper,
                     "__Qt4Ada_QWidget_setParent_1_wrapper");

   procedure setSizeIncrement_1_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Inc : not null access constant Qt4.Sizes.Internals.QSize);
   pragma Import (C, setSizeIncrement_1_wrapper,
                     "__Qt4Ada_QWidget_setSizeIncrement_1_wrapper");

   procedure setSizeIncrement_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     W : Qt4.Q_Integer;
     H : Qt4.Q_Integer);
   pragma Import (C, setSizeIncrement_0_wrapper,
                     "__Qt4Ada_QWidget_setSizeIncrement_0_wrapper");

   procedure setStatusTip_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Tip : not null access constant Qt4.Strings.Internals.QString);
   pragma Import (C, setStatusTip_0_wrapper,
                     "__Qt4Ada_QWidget_setStatusTip_0_wrapper");

   procedure setStyle_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Style : not null access Qt_Ada.Internals.Objects.QObject);
   pragma Import (C, setStyle_0_wrapper,
                     "__Qt4Ada_QWidget_setStyle_0_wrapper");

   procedure setToolTip_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Tip : not null access constant Qt4.Strings.Internals.QString);
   pragma Import (C, setToolTip_0_wrapper,
                     "__Qt4Ada_QWidget_setToolTip_0_wrapper");

   procedure setUpdatesEnabled_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Enable : Qt4.bool);
   pragma Import (C, setUpdatesEnabled_0_wrapper,
                     "__Qt4Ada_QWidget_setUpdatesEnabled_0_wrapper");

   procedure setWhatsThis_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Text : not null access constant Qt4.Strings.Internals.QString);
   pragma Import (C, setWhatsThis_0_wrapper,
                     "__Qt4Ada_QWidget_setWhatsThis_0_wrapper");

   procedure setWindowIcon_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Icon : not null access constant Qt4.Icons.Internals.QIcon);
   pragma Import (C, setWindowIcon_0_wrapper,
                     "__Qt4Ada_QWidget_setWindowIcon_0_wrapper");

   procedure setWindowIconText_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Text : not null access constant Qt4.Strings.Internals.QString);
   pragma Import (C, setWindowIconText_0_wrapper,
                     "__Qt4Ada_QWidget_setWindowIconText_0_wrapper");

   procedure setWindowRole_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Role : not null access constant Qt4.Strings.Internals.QString);
   pragma Import (C, setWindowRole_0_wrapper,
                     "__Qt4Ada_QWidget_setWindowRole_0_wrapper");

   procedure size_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Returns : not null access Qt4.Sizes.Internals.QSize);
   pragma Import (C, size_0_wrapper,
                     "__Qt4Ada_QWidget_size_0_wrapper");

   procedure sizeIncrement_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Returns : not null access Qt4.Sizes.Internals.QSize);
   pragma Import (C, sizeIncrement_0_wrapper,
                     "__Qt4Ada_QWidget_sizeIncrement_0_wrapper");

   procedure sizePolicy_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Returns : out Qt4.Size_Policies.Thin.QSizePolicy);
   pragma Import (C, sizePolicy_0_wrapper,
                     "__Qt4Ada_QWidget_sizePolicy_0_wrapper");

   procedure stackUnder_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     W : not null access Qt_Ada.Internals.Objects.QObject);
   pragma Import (C, stackUnder_0_wrapper,
                     "__Qt4Ada_QWidget_stackUnder_0_wrapper");

   procedure statusTip_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Returns : not null access Qt4.Strings.Internals.QString);
   pragma Import (C, statusTip_0_wrapper,
                     "__Qt4Ada_QWidget_statusTip_0_wrapper");

   function style_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject)
       return not null access Qt_Ada.Internals.Objects.QObject;
   pragma Import (C, style_0_wrapper,
                     "__Qt4Ada_QWidget_style_0_wrapper");

   procedure styleSheet_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Returns : not null access Qt4.Strings.Internals.QString);
   pragma Import (C, styleSheet_0_wrapper,
                     "__Qt4Ada_QWidget_styleSheet_0_wrapper");

   function testAttribute_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Attribute : Qt4.Widget_Attribute)
       return Qt4.bool;
   pragma Import (C, testAttribute_0_wrapper,
                     "__Qt4Ada_QWidget_testAttribute_0_wrapper");

   procedure toolTip_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Returns : not null access Qt4.Strings.Internals.QString);
   pragma Import (C, toolTip_0_wrapper,
                     "__Qt4Ada_QWidget_toolTip_0_wrapper");

   function underMouse_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject)
       return Qt4.bool;
   pragma Import (C, underMouse_0_wrapper,
                     "__Qt4Ada_QWidget_underMouse_0_wrapper");

   procedure unsetCursor_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject);
   pragma Import (C, unsetCursor_0_wrapper,
                     "__Qt4Ada_QWidget_unsetCursor_0_wrapper");

   procedure unsetLayoutDirection_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject);
   pragma Import (C, unsetLayoutDirection_0_wrapper,
                     "__Qt4Ada_QWidget_unsetLayoutDirection_0_wrapper");

   procedure update_3_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     X : Qt4.Q_Integer;
     Y : Qt4.Q_Integer;
     W : Qt4.Q_Integer;
     H : Qt4.Q_Integer);
   pragma Import (C, update_3_wrapper,
                     "__Qt4Ada_QWidget_update_3_wrapper");

   procedure update_2_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     R : not null access constant Qt4.Rects.Internals.QRect);
   pragma Import (C, update_2_wrapper,
                     "__Qt4Ada_QWidget_update_2_wrapper");

   procedure update_1_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Rng : not null access constant Qt4.Regions.Internals.QRegion);
   pragma Import (C, update_1_wrapper,
                     "__Qt4Ada_QWidget_update_1_wrapper");

   procedure updateGeometry_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject);
   pragma Import (C, updateGeometry_0_wrapper,
                     "__Qt4Ada_QWidget_updateGeometry_0_wrapper");

   function updatesEnabled_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject)
       return Qt4.bool;
   pragma Import (C, updatesEnabled_0_wrapper,
                     "__Qt4Ada_QWidget_updatesEnabled_0_wrapper");

   procedure visibleRegion_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Returns : not null access Qt4.Regions.Internals.QRegion);
   pragma Import (C, visibleRegion_0_wrapper,
                     "__Qt4Ada_QWidget_visibleRegion_0_wrapper");

   procedure whatsThis_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Returns : not null access Qt4.Strings.Internals.QString);
   pragma Import (C, whatsThis_0_wrapper,
                     "__Qt4Ada_QWidget_whatsThis_0_wrapper");

   function width_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject)
       return Qt4.Q_Integer;
   pragma Import (C, width_0_wrapper,
                     "__Qt4Ada_QWidget_width_0_wrapper");

   function winId_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject)
       return Qt4.W_Id;
   pragma Import (C, winId_0_wrapper,
                     "__Qt4Ada_QWidget_winId_0_wrapper");

   function window_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject)
       return not null access Qt_Ada.Internals.Objects.QObject;
   pragma Import (C, window_0_wrapper,
                     "__Qt4Ada_QWidget_window_0_wrapper");

   procedure windowIcon_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Returns : not null access Qt4.Icons.Internals.QIcon);
   pragma Import (C, windowIcon_0_wrapper,
                     "__Qt4Ada_QWidget_windowIcon_0_wrapper");

   procedure windowIconText_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Returns : not null access Qt4.Strings.Internals.QString);
   pragma Import (C, windowIconText_0_wrapper,
                     "__Qt4Ada_QWidget_windowIconText_0_wrapper");

   procedure windowRole_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Returns : not null access Qt4.Strings.Internals.QString);
   pragma Import (C, windowRole_0_wrapper,
                     "__Qt4Ada_QWidget_windowRole_0_wrapper");

   procedure windowTitle_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Returns : not null access Qt4.Strings.Internals.QString);
   pragma Import (C, windowTitle_0_wrapper,
                     "__Qt4Ada_QWidget_windowTitle_0_wrapper");

   function x_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject)
       return Qt4.Q_Integer;
   pragma Import (C, x_0_wrapper,
                     "__Qt4Ada_QWidget_x_0_wrapper");

   function y_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject)
       return Qt4.Q_Integer;
   pragma Import (C, y_0_wrapper,
                     "__Qt4Ada_QWidget_y_0_wrapper");

   function close_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject)
       return Qt4.bool;
   pragma Import (C, close_0_wrapper,
                     "__Qt4Ada_QWidget_close_0_wrapper");

   procedure hide_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject);
   pragma Import (C, hide_0_wrapper,
                     "__Qt4Ada_QWidget_hide_0_wrapper");

   procedure lower_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject);
   pragma Import (C, lower_0_wrapper,
                     "__Qt4Ada_QWidget_lower_0_wrapper");

   procedure raise_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject);
   pragma Import (C, raise_0_wrapper,
                     "__Qt4Ada_QWidget_raise_0_wrapper");

   procedure repaint_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject);
   pragma Import (C, repaint_0_wrapper,
                     "__Qt4Ada_QWidget_repaint_0_wrapper");

   procedure setDisabled_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Disable : Qt4.bool);
   pragma Import (C, setDisabled_0_wrapper,
                     "__Qt4Ada_QWidget_setDisabled_0_wrapper");

   procedure setEnabled_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Enable : Qt4.bool);
   pragma Import (C, setEnabled_0_wrapper,
                     "__Qt4Ada_QWidget_setEnabled_0_wrapper");

   procedure setFocus_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject);
   pragma Import (C, setFocus_0_wrapper,
                     "__Qt4Ada_QWidget_setFocus_0_wrapper");

   procedure setHidden_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Hidden : Qt4.bool);
   pragma Import (C, setHidden_0_wrapper,
                     "__Qt4Ada_QWidget_setHidden_0_wrapper");

   procedure setStyleSheet_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Style_Sheet : not null access constant Qt4.Strings.Internals.QString);
   pragma Import (C, setStyleSheet_0_wrapper,
                     "__Qt4Ada_QWidget_setStyleSheet_0_wrapper");

   procedure setWindowModified_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Value : Qt4.bool);
   pragma Import (C, setWindowModified_0_wrapper,
                     "__Qt4Ada_QWidget_setWindowModified_0_wrapper");

   procedure setWindowTitle_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Title : not null access constant Qt4.Strings.Internals.QString);
   pragma Import (C, setWindowTitle_0_wrapper,
                     "__Qt4Ada_QWidget_setWindowTitle_0_wrapper");

   procedure show_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject);
   pragma Import (C, show_0_wrapper,
                     "__Qt4Ada_QWidget_show_0_wrapper");

   procedure showFullScreen_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject);
   pragma Import (C, showFullScreen_0_wrapper,
                     "__Qt4Ada_QWidget_showFullScreen_0_wrapper");

   procedure showMaximized_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject);
   pragma Import (C, showMaximized_0_wrapper,
                     "__Qt4Ada_QWidget_showMaximized_0_wrapper");

   procedure showMinimized_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject);
   pragma Import (C, showMinimized_0_wrapper,
                     "__Qt4Ada_QWidget_showMinimized_0_wrapper");

   procedure showNormal_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject);
   pragma Import (C, showNormal_0_wrapper,
                     "__Qt4Ada_QWidget_showNormal_0_wrapper");

   procedure update_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject);
   pragma Import (C, update_0_wrapper,
                     "__Qt4Ada_QWidget_update_0_wrapper");

   procedure setSizePolicy_wrapper
    (Self  : not null access Qt_Ada.Internals.Objects.QObject;
     Value : Qt4.Size_Policies.Thin.QSizePolicy);
   pragma Import
    (C, setSizePolicy_wrapper, "__Qt4Ada_QWidget_setSizePolicy_wrapper");

   procedure setTabOrder_0_wrapper
    (First  : not null access Qt_Ada.Internals.Objects.QObject;
     Second : not null access Qt_Ada.Internals.Objects.QObject);
   pragma Import (C, setTabOrder_0_wrapper,
                     "__Qt4Ada_QWidget_setTabOrder_wrapper");

   procedure setWindowFlags_wrapper
    (Self  : not null access Qt_Ada.Internals.Objects.QObject;
     Value : Qt4.Window_Flags);
   pragma Import
    (C, setWindowFlags_wrapper, "__Qt4Ada_QWidget_setWindowFlags_wrapper");

   ---------------------
   -- Set_Size_Policy --
   ---------------------

   procedure Set_Size_Policy
    (Self  : not null access Q_Widget'Class;
     Value : Qt4.Size_Policies.Q_Size_Policy)
   is
   begin
      setSizePolicy_wrapper
       (Qt_Ada.Internals.Objects.Q_Object_Base'Class (Self.all).QObject_View,
        Qt4.Size_Policies.Internals.QSizePolicy_View (Value).all);
   end Set_Size_Policy;

   -------------------
   -- Set_Tab_Order --
   -------------------

   procedure Set_Tab_Order
    (First  : not null access Qt4.Widgets.Q_Widget'Class;
     Second : not null access Qt4.Widgets.Q_Widget'Class)
   is
   begin
      setTabOrder_0_wrapper
       (First.QObject_View,
        Second.QObject_View);
   end Set_Tab_Order;

   ----------------------
   -- Set_Window_Flags --
   ----------------------

   procedure Set_Window_Flags
    (Self  : not null access Q_Widget'Class;
     Value : Qt4.Window_Flags)
   is
   begin
      setWindowFlags_wrapper
       (Qt_Ada.Internals.Objects.Q_Object_Base'Class (Self.all).QObject_View,
        Value);
   end Set_Window_Flags;

   pragma Style_Checks ("N");

   ------------------
   -- Accept_Drops --
   ------------------

   function Accept_Drops
    (Self : not null access constant Q_Widget'Class)
       return Standard.Boolean
   is
   begin
      return
        Qt4.To_Boolean
         (acceptDrops_0_wrapper
           (Self.QObject_View));
   end Accept_Drops;

   ----------------------------
   -- Accessible_Description --
   ----------------------------

   function Accessible_Description
    (Self : not null access constant Q_Widget'Class)
       return Qt4.Strings.Q_String
   is
      Returns : Qt4.Strings.Q_String;

   begin
      accessibleDescription_0_wrapper
       (Self.QObject_View,
        Qt4.Strings.Internals.QString_View (Returns));

      return Returns;
   end Accessible_Description;

   ---------------------
   -- Accessible_Name --
   ---------------------

   function Accessible_Name
    (Self : not null access constant Q_Widget'Class)
       return Qt4.Strings.Q_String
   is
      Returns : Qt4.Strings.Q_String;

   begin
      accessibleName_0_wrapper
       (Self.QObject_View,
        Qt4.Strings.Internals.QString_View (Returns));

      return Returns;
   end Accessible_Name;

   ---------------------
   -- Activate_Window --
   ---------------------

   procedure Activate_Window
    (Self : not null access Q_Widget'Class)
   is
   begin
      activateWindow_0_wrapper
       (Self.QObject_View);
   end Activate_Window;

   ----------------
   -- Add_Action --
   ----------------

   procedure Add_Action
    (Self : not null access Q_Widget'Class;
     Action : not null access Qt4.Actions.Q_Action'Class)
   is
   begin
      addAction_0_wrapper
       (Self.QObject_View,
        Action.QObject_View);
   end Add_Action;

   -----------------
   -- Adjust_Size --
   -----------------

   procedure Adjust_Size
    (Self : not null access Q_Widget'Class)
   is
   begin
      adjustSize_0_wrapper
       (Self.QObject_View);
   end Adjust_Size;

   --------------------------
   -- Auto_Fill_Background --
   --------------------------

   function Auto_Fill_Background
    (Self : not null access constant Q_Widget'Class)
       return Standard.Boolean
   is
   begin
      return
        Qt4.To_Boolean
         (autoFillBackground_0_wrapper
           (Self.QObject_View));
   end Auto_Fill_Background;

   ---------------
   -- Base_Size --
   ---------------

   function Base_Size
    (Self : not null access constant Q_Widget'Class)
       return Qt4.Sizes.Q_Size
   is
      Returns : Qt4.Sizes.Q_Size;

   begin
      baseSize_0_wrapper
       (Self.QObject_View,
        Qt4.Sizes.Internals.QSize_View (Returns));

      return Returns;
   end Base_Size;

   --------------
   -- Child_At --
   --------------

   procedure Child_At
    (Self : not null access constant Q_Widget'Class;
     X : Qt4.Q_Integer;
     Y : Qt4.Q_Integer)
   is
   begin
      childAt_1_wrapper
       (Self.QObject_View,
        X,
        Y);
   end Child_At;

   --------------
   -- Child_At --
   --------------

   procedure Child_At
    (Self : not null access constant Q_Widget'Class;
     P : Qt4.Points.Q_Point)
   is
   begin
      childAt_0_wrapper
       (Self.QObject_View,
        Qt4.Points.Internals.QPoint_View (P));
   end Child_At;

   -------------------
   -- Children_Rect --
   -------------------

   function Children_Rect
    (Self : not null access constant Q_Widget'Class)
       return Qt4.Rects.Q_Rect
   is
      Returns : Qt4.Rects.Q_Rect;

   begin
      childrenRect_0_wrapper
       (Self.QObject_View,
        Qt4.Rects.Internals.QRect_View (Returns));

      return Returns;
   end Children_Rect;

   ---------------------
   -- Children_Region --
   ---------------------

   function Children_Region
    (Self : not null access constant Q_Widget'Class)
       return Qt4.Regions.Q_Region
   is
      Returns : Qt4.Regions.Q_Region;

   begin
      childrenRegion_0_wrapper
       (Self.QObject_View,
        Qt4.Regions.Internals.QRegion_View (Returns));

      return Returns;
   end Children_Region;

   -----------------
   -- Clear_Focus --
   -----------------

   procedure Clear_Focus
    (Self : not null access Q_Widget'Class)
   is
   begin
      clearFocus_0_wrapper
       (Self.QObject_View);
   end Clear_Focus;

   ----------------
   -- Clear_Mask --
   ----------------

   procedure Clear_Mask
    (Self : not null access Q_Widget'Class)
   is
   begin
      clearMask_0_wrapper
       (Self.QObject_View);
   end Clear_Mask;

   -------------------
   -- Contents_Rect --
   -------------------

   function Contents_Rect
    (Self : not null access constant Q_Widget'Class)
       return Qt4.Rects.Q_Rect
   is
      Returns : Qt4.Rects.Q_Rect;

   begin
      contentsRect_0_wrapper
       (Self.QObject_View,
        Qt4.Rects.Internals.QRect_View (Returns));

      return Returns;
   end Contents_Rect;

   -------------------------
   -- Context_Menu_Policy --
   -------------------------

   function Context_Menu_Policy
    (Self : not null access constant Q_Widget'Class)
       return Qt4.Context_Menu_Policy
   is
   begin
      return
        contextMenuPolicy_0_wrapper
         (Self.QObject_View);
   end Context_Menu_Policy;

   ------------
   -- Cursor --
   ------------

   function Cursor
    (Self : not null access constant Q_Widget'Class)
       return Qt4.Cursors.Q_Cursor
   is
      Returns : Qt4.Cursors.Q_Cursor;

   begin
      cursor_0_wrapper
       (Self.QObject_View,
        Qt4.Cursors.Internals.QCursor_View (Returns));

      return Returns;
   end Cursor;

   ----------------------
   -- Effective_Win_Id --
   ----------------------

   function Effective_Win_Id
    (Self : not null access constant Q_Widget'Class)
       return Qt4.W_Id
   is
   begin
      return
        effectiveWinId_0_wrapper
         (Self.QObject_View);
   end Effective_Win_Id;

   ---------------------
   -- Ensure_Polished --
   ---------------------

   procedure Ensure_Polished
    (Self : not null access constant Q_Widget'Class)
   is
   begin
      ensurePolished_0_wrapper
       (Self.QObject_View);
   end Ensure_Polished;

   ------------------
   -- Focus_Policy --
   ------------------

   function Focus_Policy
    (Self : not null access constant Q_Widget'Class)
       return Qt4.Focus_Policy
   is
   begin
      return
        focusPolicy_0_wrapper
         (Self.QObject_View);
   end Focus_Policy;

   -----------------
   -- Focus_Proxy --
   -----------------

   function Focus_Proxy
    (Self : not null access constant Q_Widget'Class)
       return not null access Qt4.Widgets.Q_Widget'Class
   is
   begin
      return
        Qt4.Widgets.Q_Widget'Class
         (Qt_Ada.Internals.Object_Registry.To_Q_Object
           (focusProxy_0_wrapper
             (Self.QObject_View)).all)'Access;
   end Focus_Proxy;

   ------------------
   -- Focus_Widget --
   ------------------

   function Focus_Widget
    (Self : not null access constant Q_Widget'Class)
       return not null access Qt4.Widgets.Q_Widget'Class
   is
   begin
      return
        Qt4.Widgets.Q_Widget'Class
         (Qt_Ada.Internals.Object_Registry.To_Q_Object
           (focusWidget_0_wrapper
             (Self.QObject_View)).all)'Access;
   end Focus_Widget;

   ----------
   -- Font --
   ----------

   function Font
    (Self : not null access constant Q_Widget'Class)
       return Qt4.Fonts.Q_Font
   is
      Returns : Qt4.Fonts.Q_Font;

   begin
      font_0_wrapper
       (Self.QObject_View,
        Qt4.Fonts.Internals.QFont_View (Returns));

      return Returns;
   end Font;

   ---------------
   -- Font_Info --
   ---------------

   function Font_Info
    (Self : not null access constant Q_Widget'Class)
       return Qt4.Font_Infos.Q_Font_Info
   is
   begin
      return Returns : Qt4.Font_Infos.Q_Font_Info
        := Qt4.Font_Infos.Internals.Create_Uninitialized
      do
         Qt4.Font_Infos.Internals.Set_QFontInfo_View (Returns, fontInfo_0_wrapper
          (Self.QObject_View,
           Qt4.Font_Infos.Internals.Storage (Returns)));

      end return;
   end Font_Info;

   ------------------
   -- Font_Metrics --
   ------------------

   function Font_Metrics
    (Self : not null access constant Q_Widget'Class)
       return Qt4.Font_Metrics.Q_Font_Metrics
   is
   begin
      return Returns : Qt4.Font_Metrics.Q_Font_Metrics
        := Qt4.Font_Metrics.Internals.Create_Uninitialized
      do
         Qt4.Font_Metrics.Internals.Set_QFontMetrics_View (Returns, fontMetrics_0_wrapper
          (Self.QObject_View,
           Qt4.Font_Metrics.Internals.Storage (Returns)));

      end return;
   end Font_Metrics;

   --------------------
   -- Frame_Geometry --
   --------------------

   function Frame_Geometry
    (Self : not null access constant Q_Widget'Class)
       return Qt4.Rects.Q_Rect
   is
      Returns : Qt4.Rects.Q_Rect;

   begin
      frameGeometry_0_wrapper
       (Self.QObject_View,
        Qt4.Rects.Internals.QRect_View (Returns));

      return Returns;
   end Frame_Geometry;

   ----------------
   -- Frame_Size --
   ----------------

   function Frame_Size
    (Self : not null access constant Q_Widget'Class)
       return Qt4.Sizes.Q_Size
   is
      Returns : Qt4.Sizes.Q_Size;

   begin
      frameSize_0_wrapper
       (Self.QObject_View,
        Qt4.Sizes.Internals.QSize_View (Returns));

      return Returns;
   end Frame_Size;

   -------------------
   -- Grab_Keyboard --
   -------------------

   procedure Grab_Keyboard
    (Self : not null access Q_Widget'Class)
   is
   begin
      grabKeyboard_0_wrapper
       (Self.QObject_View);
   end Grab_Keyboard;

   ----------------
   -- Grab_Mouse --
   ----------------

   procedure Grab_Mouse
    (Self : not null access Q_Widget'Class)
   is
   begin
      grabMouse_1_wrapper
       (Self.QObject_View);
   end Grab_Mouse;

   ----------------
   -- Grab_Mouse --
   ----------------

   procedure Grab_Mouse
    (Self : not null access Q_Widget'Class;
     Cursor : Qt4.Cursors.Q_Cursor)
   is
   begin
      grabMouse_0_wrapper
       (Self.QObject_View,
        Qt4.Cursors.Internals.QCursor_View (Cursor));
   end Grab_Mouse;

   ---------------
   -- Has_Focus --
   ---------------

   function Has_Focus
    (Self : not null access constant Q_Widget'Class)
       return Standard.Boolean
   is
   begin
      return
        Qt4.To_Boolean
         (hasFocus_0_wrapper
           (Self.QObject_View));
   end Has_Focus;

   ------------------------
   -- Has_Mouse_Tracking --
   ------------------------

   function Has_Mouse_Tracking
    (Self : not null access constant Q_Widget'Class)
       return Standard.Boolean
   is
   begin
      return
        Qt4.To_Boolean
         (hasMouseTracking_0_wrapper
           (Self.QObject_View));
   end Has_Mouse_Tracking;

   ------------
   -- Height --
   ------------

   function Height
    (Self : not null access constant Q_Widget'Class)
       return Qt4.Q_Integer
   is
   begin
      return
        height_0_wrapper
         (Self.QObject_View);
   end Height;

   -------------------
   -- Insert_Action --
   -------------------

   procedure Insert_Action
    (Self : not null access Q_Widget'Class;
     Before : access Qt4.Actions.Q_Action'Class;
     Action : not null access Qt4.Actions.Q_Action'Class)
   is
   begin
      insertAction_0_wrapper
       (Self.QObject_View,
        Qt_Ada.Internals.Objects.Object_Utilities.Corresponding_QObject (Before),
        Action.QObject_View);
   end Insert_Action;

   ----------------------
   -- Is_Active_Window --
   ----------------------

   function Is_Active_Window
    (Self : not null access constant Q_Widget'Class)
       return Standard.Boolean
   is
   begin
      return
        Qt4.To_Boolean
         (isActiveWindow_0_wrapper
           (Self.QObject_View));
   end Is_Active_Window;

   --------------------
   -- Is_Ancestor_Of --
   --------------------

   function Is_Ancestor_Of
    (Self : not null access constant Q_Widget'Class;
     Child : not null access constant Qt4.Widgets.Q_Widget'Class)
       return Standard.Boolean
   is
   begin
      return
        Qt4.To_Boolean
         (isAncestorOf_0_wrapper
           (Self.QObject_View,
            Child.QObject_View));
   end Is_Ancestor_Of;

   ----------------
   -- Is_Enabled --
   ----------------

   function Is_Enabled
    (Self : not null access constant Q_Widget'Class)
       return Standard.Boolean
   is
   begin
      return
        Qt4.To_Boolean
         (isEnabled_0_wrapper
           (Self.QObject_View));
   end Is_Enabled;

   -------------------
   -- Is_Enabled_To --
   -------------------

   function Is_Enabled_To
    (Self : not null access constant Q_Widget'Class;
     Ancestor : not null access Qt4.Widgets.Q_Widget'Class)
       return Standard.Boolean
   is
   begin
      return
        Qt4.To_Boolean
         (isEnabledTo_0_wrapper
           (Self.QObject_View,
            Ancestor.QObject_View));
   end Is_Enabled_To;

   --------------------
   -- Is_Full_Screen --
   --------------------

   function Is_Full_Screen
    (Self : not null access constant Q_Widget'Class)
       return Standard.Boolean
   is
   begin
      return
        Qt4.To_Boolean
         (isFullScreen_0_wrapper
           (Self.QObject_View));
   end Is_Full_Screen;

   ---------------
   -- Is_Hidden --
   ---------------

   function Is_Hidden
    (Self : not null access constant Q_Widget'Class)
       return Standard.Boolean
   is
   begin
      return
        Qt4.To_Boolean
         (isHidden_0_wrapper
           (Self.QObject_View));
   end Is_Hidden;

   ------------------
   -- Is_Maximized --
   ------------------

   function Is_Maximized
    (Self : not null access constant Q_Widget'Class)
       return Standard.Boolean
   is
   begin
      return
        Qt4.To_Boolean
         (isMaximized_0_wrapper
           (Self.QObject_View));
   end Is_Maximized;

   ------------------
   -- Is_Minimized --
   ------------------

   function Is_Minimized
    (Self : not null access constant Q_Widget'Class)
       return Standard.Boolean
   is
   begin
      return
        Qt4.To_Boolean
         (isMinimized_0_wrapper
           (Self.QObject_View));
   end Is_Minimized;

   --------------
   -- Is_Modal --
   --------------

   function Is_Modal
    (Self : not null access constant Q_Widget'Class)
       return Standard.Boolean
   is
   begin
      return
        Qt4.To_Boolean
         (isModal_0_wrapper
           (Self.QObject_View));
   end Is_Modal;

   ----------------
   -- Is_Visible --
   ----------------

   function Is_Visible
    (Self : not null access constant Q_Widget'Class)
       return Standard.Boolean
   is
   begin
      return
        Qt4.To_Boolean
         (isVisible_0_wrapper
           (Self.QObject_View));
   end Is_Visible;

   -------------------
   -- Is_Visible_To --
   -------------------

   function Is_Visible_To
    (Self : not null access constant Q_Widget'Class;
     Ancestor : not null access Qt4.Widgets.Q_Widget'Class)
       return Standard.Boolean
   is
   begin
      return
        Qt4.To_Boolean
         (isVisibleTo_0_wrapper
           (Self.QObject_View,
            Ancestor.QObject_View));
   end Is_Visible_To;

   ---------------
   -- Is_Window --
   ---------------

   function Is_Window
    (Self : not null access constant Q_Widget'Class)
       return Standard.Boolean
   is
   begin
      return
        Qt4.To_Boolean
         (isWindow_0_wrapper
           (Self.QObject_View));
   end Is_Window;

   ------------------------
   -- Is_Window_Modified --
   ------------------------

   function Is_Window_Modified
    (Self : not null access constant Q_Widget'Class)
       return Standard.Boolean
   is
   begin
      return
        Qt4.To_Boolean
         (isWindowModified_0_wrapper
           (Self.QObject_View));
   end Is_Window_Modified;

   ------------
   -- Layout --
   ------------

   function Layout
    (Self : not null access constant Q_Widget'Class)
       return not null access Qt4.Layouts.Q_Layout'Class
   is
   begin
      return
        Qt4.Layouts.Q_Layout'Class
         (Qt_Ada.Internals.Object_Registry.To_Q_Object
           (layout_0_wrapper
             (Self.QObject_View)).all)'Access;
   end Layout;

   --------------
   -- Map_From --
   --------------

   function Map_From
    (Self : not null access constant Q_Widget'Class;
     Parent : not null access Qt4.Widgets.Q_Widget'Class;
     Pos : Qt4.Points.Q_Point)
       return Qt4.Points.Q_Point
   is
      Returns : Qt4.Points.Q_Point;

   begin
      mapFrom_0_wrapper
       (Self.QObject_View,
        Parent.QObject_View,
        Qt4.Points.Internals.QPoint_View (Pos),
        Qt4.Points.Internals.QPoint_View (Returns));

      return Returns;
   end Map_From;

   ---------------------
   -- Map_From_Global --
   ---------------------

   function Map_From_Global
    (Self : not null access constant Q_Widget'Class;
     Pos : Qt4.Points.Q_Point)
       return Qt4.Points.Q_Point
   is
      Returns : Qt4.Points.Q_Point;

   begin
      mapFromGlobal_0_wrapper
       (Self.QObject_View,
        Qt4.Points.Internals.QPoint_View (Pos),
        Qt4.Points.Internals.QPoint_View (Returns));

      return Returns;
   end Map_From_Global;

   ---------------------
   -- Map_From_Parent --
   ---------------------

   function Map_From_Parent
    (Self : not null access constant Q_Widget'Class;
     Pos : Qt4.Points.Q_Point)
       return Qt4.Points.Q_Point
   is
      Returns : Qt4.Points.Q_Point;

   begin
      mapFromParent_0_wrapper
       (Self.QObject_View,
        Qt4.Points.Internals.QPoint_View (Pos),
        Qt4.Points.Internals.QPoint_View (Returns));

      return Returns;
   end Map_From_Parent;

   ------------
   -- Map_To --
   ------------

   function Map_To
    (Self : not null access constant Q_Widget'Class;
     Parent : not null access Qt4.Widgets.Q_Widget'Class;
     Pos : Qt4.Points.Q_Point)
       return Qt4.Points.Q_Point
   is
      Returns : Qt4.Points.Q_Point;

   begin
      mapTo_0_wrapper
       (Self.QObject_View,
        Parent.QObject_View,
        Qt4.Points.Internals.QPoint_View (Pos),
        Qt4.Points.Internals.QPoint_View (Returns));

      return Returns;
   end Map_To;

   -------------------
   -- Map_To_Global --
   -------------------

   function Map_To_Global
    (Self : not null access constant Q_Widget'Class;
     Pos : Qt4.Points.Q_Point)
       return Qt4.Points.Q_Point
   is
      Returns : Qt4.Points.Q_Point;

   begin
      mapToGlobal_0_wrapper
       (Self.QObject_View,
        Qt4.Points.Internals.QPoint_View (Pos),
        Qt4.Points.Internals.QPoint_View (Returns));

      return Returns;
   end Map_To_Global;

   -------------------
   -- Map_To_Parent --
   -------------------

   function Map_To_Parent
    (Self : not null access constant Q_Widget'Class;
     Pos : Qt4.Points.Q_Point)
       return Qt4.Points.Q_Point
   is
      Returns : Qt4.Points.Q_Point;

   begin
      mapToParent_0_wrapper
       (Self.QObject_View,
        Qt4.Points.Internals.QPoint_View (Pos),
        Qt4.Points.Internals.QPoint_View (Returns));

      return Returns;
   end Map_To_Parent;

   ----------
   -- Mask --
   ----------

   function Mask
    (Self : not null access constant Q_Widget'Class)
       return Qt4.Regions.Q_Region
   is
      Returns : Qt4.Regions.Q_Region;

   begin
      mask_0_wrapper
       (Self.QObject_View,
        Qt4.Regions.Internals.QRegion_View (Returns));

      return Returns;
   end Mask;

   --------------------
   -- Maximum_Height --
   --------------------

   function Maximum_Height
    (Self : not null access constant Q_Widget'Class)
       return Qt4.Q_Integer
   is
   begin
      return
        maximumHeight_0_wrapper
         (Self.QObject_View);
   end Maximum_Height;

   ------------------
   -- Maximum_Size --
   ------------------

   function Maximum_Size
    (Self : not null access constant Q_Widget'Class)
       return Qt4.Sizes.Q_Size
   is
      Returns : Qt4.Sizes.Q_Size;

   begin
      maximumSize_0_wrapper
       (Self.QObject_View,
        Qt4.Sizes.Internals.QSize_View (Returns));

      return Returns;
   end Maximum_Size;

   -------------------
   -- Maximum_Width --
   -------------------

   function Maximum_Width
    (Self : not null access constant Q_Widget'Class)
       return Qt4.Q_Integer
   is
   begin
      return
        maximumWidth_0_wrapper
         (Self.QObject_View);
   end Maximum_Width;

   --------------------
   -- Minimum_Height --
   --------------------

   function Minimum_Height
    (Self : not null access constant Q_Widget'Class)
       return Qt4.Q_Integer
   is
   begin
      return
        minimumHeight_0_wrapper
         (Self.QObject_View);
   end Minimum_Height;

   ------------------
   -- Minimum_Size --
   ------------------

   function Minimum_Size
    (Self : not null access constant Q_Widget'Class)
       return Qt4.Sizes.Q_Size
   is
      Returns : Qt4.Sizes.Q_Size;

   begin
      minimumSize_0_wrapper
       (Self.QObject_View,
        Qt4.Sizes.Internals.QSize_View (Returns));

      return Returns;
   end Minimum_Size;

   -------------------
   -- Minimum_Width --
   -------------------

   function Minimum_Width
    (Self : not null access constant Q_Widget'Class)
       return Qt4.Q_Integer
   is
   begin
      return
        minimumWidth_0_wrapper
         (Self.QObject_View);
   end Minimum_Width;

   ----------
   -- Move --
   ----------

   procedure Move
    (Self : not null access Q_Widget'Class;
     Pos : Qt4.Points.Q_Point)
   is
   begin
      move_1_wrapper
       (Self.QObject_View,
        Qt4.Points.Internals.QPoint_View (Pos));
   end Move;

   ----------
   -- Move --
   ----------

   procedure Move
    (Self : not null access Q_Widget'Class;
     X : Qt4.Q_Integer;
     Y : Qt4.Q_Integer)
   is
   begin
      move_0_wrapper
       (Self.QObject_View,
        X,
        Y);
   end Move;

   -------------------------
   -- Next_In_Focus_Chain --
   -------------------------

   function Next_In_Focus_Chain
    (Self : not null access constant Q_Widget'Class)
       return not null access Qt4.Widgets.Q_Widget'Class
   is
   begin
      return
        Qt4.Widgets.Q_Widget'Class
         (Qt_Ada.Internals.Object_Registry.To_Q_Object
           (nextInFocusChain_0_wrapper
             (Self.QObject_View)).all)'Access;
   end Next_In_Focus_Chain;

   ---------------------
   -- Normal_Geometry --
   ---------------------

   function Normal_Geometry
    (Self : not null access constant Q_Widget'Class)
       return Qt4.Rects.Q_Rect
   is
      Returns : Qt4.Rects.Q_Rect;

   begin
      normalGeometry_0_wrapper
       (Self.QObject_View,
        Qt4.Rects.Internals.QRect_View (Returns));

      return Returns;
   end Normal_Geometry;

   -------------
   -- Palette --
   -------------

   function Palette
    (Self : not null access constant Q_Widget'Class)
       return Qt4.Palettes.Q_Palette
   is
      Returns : Qt4.Palettes.Q_Palette;

   begin
      palette_0_wrapper
       (Self.QObject_View,
        Qt4.Palettes.Internals.QPalette_View (Returns).all);

      return Returns;
   end Palette;

   -------------------
   -- Parent_Widget --
   -------------------

   function Parent_Widget
    (Self : not null access constant Q_Widget'Class)
       return not null access Qt4.Widgets.Q_Widget'Class
   is
   begin
      return
        Qt4.Widgets.Q_Widget'Class
         (Qt_Ada.Internals.Object_Registry.To_Q_Object
           (parentWidget_0_wrapper
             (Self.QObject_View)).all)'Access;
   end Parent_Widget;

   ---------
   -- Pos --
   ---------

   function Pos
    (Self : not null access constant Q_Widget'Class)
       return Qt4.Points.Q_Point
   is
      Returns : Qt4.Points.Q_Point;

   begin
      pos_0_wrapper
       (Self.QObject_View,
        Qt4.Points.Internals.QPoint_View (Returns));

      return Returns;
   end Pos;

   ----------
   -- Rect --
   ----------

   function Rect
    (Self : not null access constant Q_Widget'Class)
       return Qt4.Rects.Q_Rect
   is
      Returns : Qt4.Rects.Q_Rect;

   begin
      rect_0_wrapper
       (Self.QObject_View,
        Qt4.Rects.Internals.QRect_View (Returns));

      return Returns;
   end Rect;

   ----------------------
   -- Release_Keyboard --
   ----------------------

   procedure Release_Keyboard
    (Self : not null access Q_Widget'Class)
   is
   begin
      releaseKeyboard_0_wrapper
       (Self.QObject_View);
   end Release_Keyboard;

   -------------------
   -- Release_Mouse --
   -------------------

   procedure Release_Mouse
    (Self : not null access Q_Widget'Class)
   is
   begin
      releaseMouse_0_wrapper
       (Self.QObject_View);
   end Release_Mouse;

   -------------------
   -- Remove_Action --
   -------------------

   procedure Remove_Action
    (Self : not null access Q_Widget'Class;
     Action : not null access Qt4.Actions.Q_Action'Class)
   is
   begin
      removeAction_0_wrapper
       (Self.QObject_View,
        Action.QObject_View);
   end Remove_Action;

   -------------
   -- Repaint --
   -------------

   procedure Repaint
    (Self : not null access Q_Widget'Class;
     X : Qt4.Q_Integer;
     Y : Qt4.Q_Integer;
     W : Qt4.Q_Integer;
     H : Qt4.Q_Integer)
   is
   begin
      repaint_3_wrapper
       (Self.QObject_View,
        X,
        Y,
        W,
        H);
   end Repaint;

   -------------
   -- Repaint --
   -------------

   procedure Repaint
    (Self : not null access Q_Widget'Class;
     R : Qt4.Rects.Q_Rect)
   is
   begin
      repaint_2_wrapper
       (Self.QObject_View,
        Qt4.Rects.Internals.QRect_View (R));
   end Repaint;

   -------------
   -- Repaint --
   -------------

   procedure Repaint
    (Self : not null access Q_Widget'Class;
     Rng : Qt4.Regions.Q_Region)
   is
   begin
      repaint_1_wrapper
       (Self.QObject_View,
        Qt4.Regions.Internals.QRegion_View (Rng));
   end Repaint;

   ------------
   -- Resize --
   ------------

   procedure Resize
    (Self : not null access Q_Widget'Class;
     Size : Qt4.Sizes.Q_Size)
   is
   begin
      resize_1_wrapper
       (Self.QObject_View,
        Qt4.Sizes.Internals.QSize_View (Size));
   end Resize;

   ------------
   -- Resize --
   ------------

   procedure Resize
    (Self : not null access Q_Widget'Class;
     W : Qt4.Q_Integer;
     H : Qt4.Q_Integer)
   is
   begin
      resize_0_wrapper
       (Self.QObject_View,
        W,
        H);
   end Resize;

   ----------------------
   -- Restore_Geometry --
   ----------------------

   procedure Restore_Geometry
    (Self : not null access Q_Widget'Class;
     Geometry : Qt4.Byte_Arrays.Q_Byte_Array)
   is
   begin
      restoreGeometry_0_wrapper
       (Self.QObject_View,
        Qt4.Byte_Arrays.Internals.QByteArray_View (Geometry));
   end Restore_Geometry;

   -------------------
   -- Save_Geometry --
   -------------------

   function Save_Geometry
    (Self : not null access constant Q_Widget'Class)
       return Qt4.Byte_Arrays.Q_Byte_Array
   is
      Returns : Qt4.Byte_Arrays.Q_Byte_Array;

   begin
      saveGeometry_0_wrapper
       (Self.QObject_View,
        Qt4.Byte_Arrays.Internals.QByteArray_View (Returns));

      return Returns;
   end Save_Geometry;

   ------------
   -- Scroll --
   ------------

   procedure Scroll
    (Self : not null access Q_Widget'Class;
     Dx : Qt4.Q_Integer;
     Dy : Qt4.Q_Integer)
   is
   begin
      scroll_1_wrapper
       (Self.QObject_View,
        Dx,
        Dy);
   end Scroll;

   ------------
   -- Scroll --
   ------------

   procedure Scroll
    (Self : not null access Q_Widget'Class;
     Dx : Qt4.Q_Integer;
     Dy : Qt4.Q_Integer;
     R : Qt4.Rects.Q_Rect)
   is
   begin
      scroll_0_wrapper
       (Self.QObject_View,
        Dx,
        Dy,
        Qt4.Rects.Internals.QRect_View (R));
   end Scroll;

   ----------------------
   -- Set_Accept_Drops --
   ----------------------

   procedure Set_Accept_Drops
    (Self : not null access Q_Widget'Class;
     On : Standard.Boolean)
   is
   begin
      setAcceptDrops_0_wrapper
       (Self.QObject_View,
        Qt4.To_bool (On));
   end Set_Accept_Drops;

   --------------------------------
   -- Set_Accessible_Description --
   --------------------------------

   procedure Set_Accessible_Description
    (Self : not null access Q_Widget'Class;
     Description : Qt4.Strings.Q_String)
   is
   begin
      setAccessibleDescription_0_wrapper
       (Self.QObject_View,
        Qt4.Strings.Internals.QString_View (Description));
   end Set_Accessible_Description;

   -------------------------
   -- Set_Accessible_Name --
   -------------------------

   procedure Set_Accessible_Name
    (Self : not null access Q_Widget'Class;
     Name : Qt4.Strings.Q_String)
   is
   begin
      setAccessibleName_0_wrapper
       (Self.QObject_View,
        Qt4.Strings.Internals.QString_View (Name));
   end Set_Accessible_Name;

   -------------------
   -- Set_Attribute --
   -------------------

   procedure Set_Attribute
    (Self : not null access Q_Widget'Class;
     Attribute : Qt4.Widget_Attribute;
     On : Standard.Boolean
       := True)
   is
   begin
      setAttribute_0_wrapper
       (Self.QObject_View,
        Attribute,
        Qt4.To_bool (On));
   end Set_Attribute;

   ------------------------------
   -- Set_Auto_Fill_Background --
   ------------------------------

   procedure Set_Auto_Fill_Background
    (Self : not null access Q_Widget'Class;
     On : Standard.Boolean)
   is
   begin
      setAutoFillBackground_0_wrapper
       (Self.QObject_View,
        Qt4.To_bool (On));
   end Set_Auto_Fill_Background;

   -------------------
   -- Set_Base_Size --
   -------------------

   procedure Set_Base_Size
    (Self : not null access Q_Widget'Class;
     Size : Qt4.Sizes.Q_Size)
   is
   begin
      setBaseSize_1_wrapper
       (Self.QObject_View,
        Qt4.Sizes.Internals.QSize_View (Size));
   end Set_Base_Size;

   -------------------
   -- Set_Base_Size --
   -------------------

   procedure Set_Base_Size
    (Self : not null access Q_Widget'Class;
     Basew : Qt4.Q_Integer;
     Baseh : Qt4.Q_Integer)
   is
   begin
      setBaseSize_0_wrapper
       (Self.QObject_View,
        Basew,
        Baseh);
   end Set_Base_Size;

   --------------------------
   -- Set_Contents_Margins --
   --------------------------

   procedure Set_Contents_Margins
    (Self : not null access Q_Widget'Class;
     Left : Qt4.Q_Integer;
     Top : Qt4.Q_Integer;
     Right : Qt4.Q_Integer;
     Bottom : Qt4.Q_Integer)
   is
   begin
      setContentsMargins_0_wrapper
       (Self.QObject_View,
        Left,
        Top,
        Right,
        Bottom);
   end Set_Contents_Margins;

   -----------------------------
   -- Set_Context_Menu_Policy --
   -----------------------------

   procedure Set_Context_Menu_Policy
    (Self : not null access Q_Widget'Class;
     Policy : Qt4.Context_Menu_Policy)
   is
   begin
      setContextMenuPolicy_0_wrapper
       (Self.QObject_View,
        Policy);
   end Set_Context_Menu_Policy;

   ----------------
   -- Set_Cursor --
   ----------------

   procedure Set_Cursor
    (Self : not null access Q_Widget'Class;
     Cursor : Qt4.Cursors.Q_Cursor)
   is
   begin
      setCursor_0_wrapper
       (Self.QObject_View,
        Qt4.Cursors.Internals.QCursor_View (Cursor));
   end Set_Cursor;

   ----------------------
   -- Set_Fixed_Height --
   ----------------------

   procedure Set_Fixed_Height
    (Self : not null access Q_Widget'Class;
     H : Qt4.Q_Integer)
   is
   begin
      setFixedHeight_0_wrapper
       (Self.QObject_View,
        H);
   end Set_Fixed_Height;

   --------------------
   -- Set_Fixed_Size --
   --------------------

   procedure Set_Fixed_Size
    (Self : not null access Q_Widget'Class;
     Size : Qt4.Sizes.Q_Size)
   is
   begin
      setFixedSize_1_wrapper
       (Self.QObject_View,
        Qt4.Sizes.Internals.QSize_View (Size));
   end Set_Fixed_Size;

   --------------------
   -- Set_Fixed_Size --
   --------------------

   procedure Set_Fixed_Size
    (Self : not null access Q_Widget'Class;
     W : Qt4.Q_Integer;
     H : Qt4.Q_Integer)
   is
   begin
      setFixedSize_0_wrapper
       (Self.QObject_View,
        W,
        H);
   end Set_Fixed_Size;

   ---------------------
   -- Set_Fixed_Width --
   ---------------------

   procedure Set_Fixed_Width
    (Self : not null access Q_Widget'Class;
     H : Qt4.Q_Integer)
   is
   begin
      setFixedWidth_0_wrapper
       (Self.QObject_View,
        H);
   end Set_Fixed_Width;

   ---------------
   -- Set_Focus --
   ---------------

   procedure Set_Focus
    (Self : not null access Q_Widget'Class;
     Reason : Qt4.Focus_Reason)
   is
   begin
      setFocus_1_wrapper
       (Self.QObject_View,
        Reason);
   end Set_Focus;

   ----------------------
   -- Set_Focus_Policy --
   ----------------------

   procedure Set_Focus_Policy
    (Self : not null access Q_Widget'Class;
     Policy : Qt4.Focus_Policy)
   is
   begin
      setFocusPolicy_0_wrapper
       (Self.QObject_View,
        Policy);
   end Set_Focus_Policy;

   ---------------------
   -- Set_Focus_Proxy --
   ---------------------

   procedure Set_Focus_Proxy
    (Self : not null access Q_Widget'Class;
     W : not null access Qt4.Widgets.Q_Widget'Class)
   is
   begin
      setFocusProxy_0_wrapper
       (Self.QObject_View,
        W.QObject_View);
   end Set_Focus_Proxy;

   --------------
   -- Set_Font --
   --------------

   procedure Set_Font
    (Self : not null access Q_Widget'Class;
     Font : Qt4.Fonts.Q_Font)
   is
   begin
      setFont_0_wrapper
       (Self.QObject_View,
        Qt4.Fonts.Internals.QFont_View (Font));
   end Set_Font;

   ------------------
   -- Set_Geometry --
   ------------------

   procedure Set_Geometry
    (Self : not null access Q_Widget'Class;
     R : Qt4.Rects.Q_Rect)
   is
   begin
      setGeometry_1_wrapper
       (Self.QObject_View,
        Qt4.Rects.Internals.QRect_View (R));
   end Set_Geometry;

   ------------------
   -- Set_Geometry --
   ------------------

   procedure Set_Geometry
    (Self : not null access Q_Widget'Class;
     X : Qt4.Q_Integer;
     Y : Qt4.Q_Integer;
     W : Qt4.Q_Integer;
     H : Qt4.Q_Integer)
   is
   begin
      setGeometry_0_wrapper
       (Self.QObject_View,
        X,
        Y,
        W,
        H);
   end Set_Geometry;

   ----------------
   -- Set_Layout --
   ----------------

   procedure Set_Layout
    (Self : not null access Q_Widget'Class;
     Layout : not null access Qt4.Layouts.Q_Layout'Class)
   is
   begin
      setLayout_0_wrapper
       (Self.QObject_View,
        Layout.QObject_View);
   end Set_Layout;

   --------------
   -- Set_Mask --
   --------------

   procedure Set_Mask
    (Self : not null access Q_Widget'Class;
     Region : Qt4.Regions.Q_Region)
   is
   begin
      setMask_0_wrapper
       (Self.QObject_View,
        Qt4.Regions.Internals.QRegion_View (Region));
   end Set_Mask;

   ------------------------
   -- Set_Maximum_Height --
   ------------------------

   procedure Set_Maximum_Height
    (Self : not null access Q_Widget'Class;
     Maxh : Qt4.Q_Integer)
   is
   begin
      setMaximumHeight_0_wrapper
       (Self.QObject_View,
        Maxh);
   end Set_Maximum_Height;

   ----------------------
   -- Set_Maximum_Size --
   ----------------------

   procedure Set_Maximum_Size
    (Self : not null access Q_Widget'Class;
     Size : Qt4.Sizes.Q_Size)
   is
   begin
      setMaximumSize_1_wrapper
       (Self.QObject_View,
        Qt4.Sizes.Internals.QSize_View (Size));
   end Set_Maximum_Size;

   ----------------------
   -- Set_Maximum_Size --
   ----------------------

   procedure Set_Maximum_Size
    (Self : not null access Q_Widget'Class;
     Maxw : Qt4.Q_Integer;
     Maxh : Qt4.Q_Integer)
   is
   begin
      setMaximumSize_0_wrapper
       (Self.QObject_View,
        Maxw,
        Maxh);
   end Set_Maximum_Size;

   -----------------------
   -- Set_Maximum_Width --
   -----------------------

   procedure Set_Maximum_Width
    (Self : not null access Q_Widget'Class;
     Maxw : Qt4.Q_Integer)
   is
   begin
      setMaximumWidth_0_wrapper
       (Self.QObject_View,
        Maxw);
   end Set_Maximum_Width;

   ------------------------
   -- Set_Minimum_Height --
   ------------------------

   procedure Set_Minimum_Height
    (Self : not null access Q_Widget'Class;
     Minh : Qt4.Q_Integer)
   is
   begin
      setMinimumHeight_0_wrapper
       (Self.QObject_View,
        Minh);
   end Set_Minimum_Height;

   ----------------------
   -- Set_Minimum_Size --
   ----------------------

   procedure Set_Minimum_Size
    (Self : not null access Q_Widget'Class;
     Size : Qt4.Sizes.Q_Size)
   is
   begin
      setMinimumSize_1_wrapper
       (Self.QObject_View,
        Qt4.Sizes.Internals.QSize_View (Size));
   end Set_Minimum_Size;

   ----------------------
   -- Set_Minimum_Size --
   ----------------------

   procedure Set_Minimum_Size
    (Self : not null access Q_Widget'Class;
     Minw : Qt4.Q_Integer;
     Minh : Qt4.Q_Integer)
   is
   begin
      setMinimumSize_0_wrapper
       (Self.QObject_View,
        Minw,
        Minh);
   end Set_Minimum_Size;

   -----------------------
   -- Set_Minimum_Width --
   -----------------------

   procedure Set_Minimum_Width
    (Self : not null access Q_Widget'Class;
     Minw : Qt4.Q_Integer)
   is
   begin
      setMinimumWidth_0_wrapper
       (Self.QObject_View,
        Minw);
   end Set_Minimum_Width;

   ------------------------
   -- Set_Mouse_Tracking --
   ------------------------

   procedure Set_Mouse_Tracking
    (Self : not null access Q_Widget'Class;
     Enable : Standard.Boolean)
   is
   begin
      setMouseTracking_0_wrapper
       (Self.QObject_View,
        Qt4.To_bool (Enable));
   end Set_Mouse_Tracking;

   -----------------
   -- Set_Palette --
   -----------------

   procedure Set_Palette
    (Self : not null access Q_Widget'Class;
     Palette : Qt4.Palettes.Q_Palette)
   is
   begin
      setPalette_0_wrapper
       (Self.QObject_View,
        Qt4.Palettes.Internals.QPalette_View (Palette));
   end Set_Palette;

   ----------------
   -- Set_Parent --
   ----------------

   procedure Set_Parent
    (Self : not null access Q_Widget'Class;
     Parent : not null access Qt4.Widgets.Q_Widget'Class)
   is
   begin
      setParent_1_wrapper
       (Self.QObject_View,
        Parent.QObject_View);
   end Set_Parent;

   ------------------------
   -- Set_Size_Increment --
   ------------------------

   procedure Set_Size_Increment
    (Self : not null access Q_Widget'Class;
     Inc : Qt4.Sizes.Q_Size)
   is
   begin
      setSizeIncrement_1_wrapper
       (Self.QObject_View,
        Qt4.Sizes.Internals.QSize_View (Inc));
   end Set_Size_Increment;

   ------------------------
   -- Set_Size_Increment --
   ------------------------

   procedure Set_Size_Increment
    (Self : not null access Q_Widget'Class;
     W : Qt4.Q_Integer;
     H : Qt4.Q_Integer)
   is
   begin
      setSizeIncrement_0_wrapper
       (Self.QObject_View,
        W,
        H);
   end Set_Size_Increment;

   --------------------
   -- Set_Status_Tip --
   --------------------

   procedure Set_Status_Tip
    (Self : not null access Q_Widget'Class;
     Tip : Qt4.Strings.Q_String)
   is
   begin
      setStatusTip_0_wrapper
       (Self.QObject_View,
        Qt4.Strings.Internals.QString_View (Tip));
   end Set_Status_Tip;

   ---------------
   -- Set_Style --
   ---------------

   procedure Set_Style
    (Self : not null access Q_Widget'Class;
     Style : not null access Qt4.Styles.Q_Style'Class)
   is
   begin
      setStyle_0_wrapper
       (Self.QObject_View,
        Style.QObject_View);
   end Set_Style;

   ------------------
   -- Set_Tool_Tip --
   ------------------

   procedure Set_Tool_Tip
    (Self : not null access Q_Widget'Class;
     Tip : Qt4.Strings.Q_String)
   is
   begin
      setToolTip_0_wrapper
       (Self.QObject_View,
        Qt4.Strings.Internals.QString_View (Tip));
   end Set_Tool_Tip;

   -------------------------
   -- Set_Updates_Enabled --
   -------------------------

   procedure Set_Updates_Enabled
    (Self : not null access Q_Widget'Class;
     Enable : Standard.Boolean)
   is
   begin
      setUpdatesEnabled_0_wrapper
       (Self.QObject_View,
        Qt4.To_bool (Enable));
   end Set_Updates_Enabled;

   --------------------
   -- Set_Whats_This --
   --------------------

   procedure Set_Whats_This
    (Self : not null access Q_Widget'Class;
     Text : Qt4.Strings.Q_String)
   is
   begin
      setWhatsThis_0_wrapper
       (Self.QObject_View,
        Qt4.Strings.Internals.QString_View (Text));
   end Set_Whats_This;

   ---------------------
   -- Set_Window_Icon --
   ---------------------

   procedure Set_Window_Icon
    (Self : not null access Q_Widget'Class;
     Icon : Qt4.Icons.Q_Icon)
   is
   begin
      setWindowIcon_0_wrapper
       (Self.QObject_View,
        Qt4.Icons.Internals.QIcon_View (Icon));
   end Set_Window_Icon;

   --------------------------
   -- Set_Window_Icon_Text --
   --------------------------

   procedure Set_Window_Icon_Text
    (Self : not null access Q_Widget'Class;
     Text : Qt4.Strings.Q_String)
   is
   begin
      setWindowIconText_0_wrapper
       (Self.QObject_View,
        Qt4.Strings.Internals.QString_View (Text));
   end Set_Window_Icon_Text;

   ---------------------
   -- Set_Window_Role --
   ---------------------

   procedure Set_Window_Role
    (Self : not null access Q_Widget'Class;
     Role : Qt4.Strings.Q_String)
   is
   begin
      setWindowRole_0_wrapper
       (Self.QObject_View,
        Qt4.Strings.Internals.QString_View (Role));
   end Set_Window_Role;

   ----------
   -- Size --
   ----------

   function Size
    (Self : not null access constant Q_Widget'Class)
       return Qt4.Sizes.Q_Size
   is
      Returns : Qt4.Sizes.Q_Size;

   begin
      size_0_wrapper
       (Self.QObject_View,
        Qt4.Sizes.Internals.QSize_View (Returns));

      return Returns;
   end Size;

   --------------------
   -- Size_Increment --
   --------------------

   function Size_Increment
    (Self : not null access constant Q_Widget'Class)
       return Qt4.Sizes.Q_Size
   is
      Returns : Qt4.Sizes.Q_Size;

   begin
      sizeIncrement_0_wrapper
       (Self.QObject_View,
        Qt4.Sizes.Internals.QSize_View (Returns));

      return Returns;
   end Size_Increment;

   -----------------
   -- Size_Policy --
   -----------------

   function Size_Policy
    (Self : not null access constant Q_Widget'Class)
       return Qt4.Size_Policies.Q_Size_Policy
   is
      Returns : Qt4.Size_Policies.Q_Size_Policy;

   begin
      sizePolicy_0_wrapper
       (Self.QObject_View,
        Qt4.Size_Policies.Internals.QSizePolicy_View (Returns).all);

      return Returns;
   end Size_Policy;

   -----------------
   -- Stack_Under --
   -----------------

   procedure Stack_Under
    (Self : not null access Q_Widget'Class;
     W : not null access Qt4.Widgets.Q_Widget'Class)
   is
   begin
      stackUnder_0_wrapper
       (Self.QObject_View,
        W.QObject_View);
   end Stack_Under;

   ----------------
   -- Status_Tip --
   ----------------

   function Status_Tip
    (Self : not null access constant Q_Widget'Class)
       return Qt4.Strings.Q_String
   is
      Returns : Qt4.Strings.Q_String;

   begin
      statusTip_0_wrapper
       (Self.QObject_View,
        Qt4.Strings.Internals.QString_View (Returns));

      return Returns;
   end Status_Tip;

   -----------
   -- Style --
   -----------

   function Style
    (Self : not null access constant Q_Widget'Class)
       return not null access Qt4.Styles.Q_Style'Class
   is
   begin
      return
        Qt4.Styles.Q_Style'Class
         (Qt_Ada.Internals.Object_Registry.To_Q_Object
           (style_0_wrapper
             (Self.QObject_View)).all)'Access;
   end Style;

   -----------------
   -- Style_Sheet --
   -----------------

   function Style_Sheet
    (Self : not null access constant Q_Widget'Class)
       return Qt4.Strings.Q_String
   is
      Returns : Qt4.Strings.Q_String;

   begin
      styleSheet_0_wrapper
       (Self.QObject_View,
        Qt4.Strings.Internals.QString_View (Returns));

      return Returns;
   end Style_Sheet;

   --------------------
   -- Test_Attribute --
   --------------------

   function Test_Attribute
    (Self : not null access constant Q_Widget'Class;
     Attribute : Qt4.Widget_Attribute)
       return Standard.Boolean
   is
   begin
      return
        Qt4.To_Boolean
         (testAttribute_0_wrapper
           (Self.QObject_View,
            Attribute));
   end Test_Attribute;

   --------------
   -- Tool_Tip --
   --------------

   function Tool_Tip
    (Self : not null access constant Q_Widget'Class)
       return Qt4.Strings.Q_String
   is
      Returns : Qt4.Strings.Q_String;

   begin
      toolTip_0_wrapper
       (Self.QObject_View,
        Qt4.Strings.Internals.QString_View (Returns));

      return Returns;
   end Tool_Tip;

   -----------------
   -- Under_Mouse --
   -----------------

   function Under_Mouse
    (Self : not null access constant Q_Widget'Class)
       return Standard.Boolean
   is
   begin
      return
        Qt4.To_Boolean
         (underMouse_0_wrapper
           (Self.QObject_View));
   end Under_Mouse;

   ------------------
   -- Unset_Cursor --
   ------------------

   procedure Unset_Cursor
    (Self : not null access Q_Widget'Class)
   is
   begin
      unsetCursor_0_wrapper
       (Self.QObject_View);
   end Unset_Cursor;

   ----------------------------
   -- Unset_Layout_Direction --
   ----------------------------

   procedure Unset_Layout_Direction
    (Self : not null access Q_Widget'Class)
   is
   begin
      unsetLayoutDirection_0_wrapper
       (Self.QObject_View);
   end Unset_Layout_Direction;

   ------------
   -- Update --
   ------------

   procedure Update
    (Self : not null access Q_Widget'Class;
     X : Qt4.Q_Integer;
     Y : Qt4.Q_Integer;
     W : Qt4.Q_Integer;
     H : Qt4.Q_Integer)
   is
   begin
      update_3_wrapper
       (Self.QObject_View,
        X,
        Y,
        W,
        H);
   end Update;

   ------------
   -- Update --
   ------------

   procedure Update
    (Self : not null access Q_Widget'Class;
     R : Qt4.Rects.Q_Rect)
   is
   begin
      update_2_wrapper
       (Self.QObject_View,
        Qt4.Rects.Internals.QRect_View (R));
   end Update;

   ------------
   -- Update --
   ------------

   procedure Update
    (Self : not null access Q_Widget'Class;
     Rng : Qt4.Regions.Q_Region)
   is
   begin
      update_1_wrapper
       (Self.QObject_View,
        Qt4.Regions.Internals.QRegion_View (Rng));
   end Update;

   ---------------------
   -- Update_Geometry --
   ---------------------

   procedure Update_Geometry
    (Self : not null access Q_Widget'Class)
   is
   begin
      updateGeometry_0_wrapper
       (Self.QObject_View);
   end Update_Geometry;

   ---------------------
   -- Updates_Enabled --
   ---------------------

   function Updates_Enabled
    (Self : not null access constant Q_Widget'Class)
       return Standard.Boolean
   is
   begin
      return
        Qt4.To_Boolean
         (updatesEnabled_0_wrapper
           (Self.QObject_View));
   end Updates_Enabled;

   --------------------
   -- Visible_Region --
   --------------------

   function Visible_Region
    (Self : not null access constant Q_Widget'Class)
       return Qt4.Regions.Q_Region
   is
      Returns : Qt4.Regions.Q_Region;

   begin
      visibleRegion_0_wrapper
       (Self.QObject_View,
        Qt4.Regions.Internals.QRegion_View (Returns));

      return Returns;
   end Visible_Region;

   ----------------
   -- Whats_This --
   ----------------

   function Whats_This
    (Self : not null access constant Q_Widget'Class)
       return Qt4.Strings.Q_String
   is
      Returns : Qt4.Strings.Q_String;

   begin
      whatsThis_0_wrapper
       (Self.QObject_View,
        Qt4.Strings.Internals.QString_View (Returns));

      return Returns;
   end Whats_This;

   -----------
   -- Width --
   -----------

   function Width
    (Self : not null access constant Q_Widget'Class)
       return Qt4.Q_Integer
   is
   begin
      return
        width_0_wrapper
         (Self.QObject_View);
   end Width;

   ------------
   -- Win_Id --
   ------------

   function Win_Id
    (Self : not null access constant Q_Widget'Class)
       return Qt4.W_Id
   is
   begin
      return
        winId_0_wrapper
         (Self.QObject_View);
   end Win_Id;

   ------------
   -- Window --
   ------------

   function Window
    (Self : not null access constant Q_Widget'Class)
       return not null access Qt4.Widgets.Q_Widget'Class
   is
   begin
      return
        Qt4.Widgets.Q_Widget'Class
         (Qt_Ada.Internals.Object_Registry.To_Q_Object
           (window_0_wrapper
             (Self.QObject_View)).all)'Access;
   end Window;

   -----------------
   -- Window_Icon --
   -----------------

   function Window_Icon
    (Self : not null access constant Q_Widget'Class)
       return Qt4.Icons.Q_Icon
   is
      Returns : Qt4.Icons.Q_Icon;

   begin
      windowIcon_0_wrapper
       (Self.QObject_View,
        Qt4.Icons.Internals.QIcon_View (Returns));

      return Returns;
   end Window_Icon;

   ----------------------
   -- Window_Icon_Text --
   ----------------------

   function Window_Icon_Text
    (Self : not null access constant Q_Widget'Class)
       return Qt4.Strings.Q_String
   is
      Returns : Qt4.Strings.Q_String;

   begin
      windowIconText_0_wrapper
       (Self.QObject_View,
        Qt4.Strings.Internals.QString_View (Returns));

      return Returns;
   end Window_Icon_Text;

   -----------------
   -- Window_Role --
   -----------------

   function Window_Role
    (Self : not null access constant Q_Widget'Class)
       return Qt4.Strings.Q_String
   is
      Returns : Qt4.Strings.Q_String;

   begin
      windowRole_0_wrapper
       (Self.QObject_View,
        Qt4.Strings.Internals.QString_View (Returns));

      return Returns;
   end Window_Role;

   ------------------
   -- Window_Title --
   ------------------

   function Window_Title
    (Self : not null access constant Q_Widget'Class)
       return Qt4.Strings.Q_String
   is
      Returns : Qt4.Strings.Q_String;

   begin
      windowTitle_0_wrapper
       (Self.QObject_View,
        Qt4.Strings.Internals.QString_View (Returns));

      return Returns;
   end Window_Title;

   -------
   -- X --
   -------

   function X
    (Self : not null access constant Q_Widget'Class)
       return Qt4.Q_Integer
   is
   begin
      return
        x_0_wrapper
         (Self.QObject_View);
   end X;

   -------
   -- Y --
   -------

   function Y
    (Self : not null access constant Q_Widget'Class)
       return Qt4.Q_Integer
   is
   begin
      return
        y_0_wrapper
         (Self.QObject_View);
   end Y;

   -----------
   -- Close --
   -----------

   function Close
    (Self : not null access Q_Widget'Class)
       return Standard.Boolean
   is
   begin
      return
        Qt4.To_Boolean
         (close_0_wrapper
           (Self.QObject_View));
   end Close;

   ----------
   -- Hide --
   ----------

   procedure Hide
    (Self : not null access Q_Widget'Class)
   is
   begin
      hide_0_wrapper
       (Self.QObject_View);
   end Hide;

   -----------
   -- Lower --
   -----------

   procedure Lower
    (Self : not null access Q_Widget'Class)
   is
   begin
      lower_0_wrapper
       (Self.QObject_View);
   end Lower;

   ------------------
   -- Raise_Widget --
   ------------------

   procedure Raise_Widget
    (Self : not null access Q_Widget'Class)
   is
   begin
      raise_0_wrapper
       (Self.QObject_View);
   end Raise_Widget;

   -------------
   -- Repaint --
   -------------

   procedure Repaint
    (Self : not null access Q_Widget'Class)
   is
   begin
      repaint_0_wrapper
       (Self.QObject_View);
   end Repaint;

   ------------------
   -- Set_Disabled --
   ------------------

   procedure Set_Disabled
    (Self : not null access Q_Widget'Class;
     Disable : Standard.Boolean)
   is
   begin
      setDisabled_0_wrapper
       (Self.QObject_View,
        Qt4.To_bool (Disable));
   end Set_Disabled;

   -----------------
   -- Set_Enabled --
   -----------------

   procedure Set_Enabled
    (Self : not null access Q_Widget'Class;
     Enable : Standard.Boolean)
   is
   begin
      setEnabled_0_wrapper
       (Self.QObject_View,
        Qt4.To_bool (Enable));
   end Set_Enabled;

   ---------------
   -- Set_Focus --
   ---------------

   procedure Set_Focus
    (Self : not null access Q_Widget'Class)
   is
   begin
      setFocus_0_wrapper
       (Self.QObject_View);
   end Set_Focus;

   ----------------
   -- Set_Hidden --
   ----------------

   procedure Set_Hidden
    (Self : not null access Q_Widget'Class;
     Hidden : Standard.Boolean)
   is
   begin
      setHidden_0_wrapper
       (Self.QObject_View,
        Qt4.To_bool (Hidden));
   end Set_Hidden;

   ---------------------
   -- Set_Style_Sheet --
   ---------------------

   procedure Set_Style_Sheet
    (Self : not null access Q_Widget'Class;
     Style_Sheet : Qt4.Strings.Q_String)
   is
   begin
      setStyleSheet_0_wrapper
       (Self.QObject_View,
        Qt4.Strings.Internals.QString_View (Style_Sheet));
   end Set_Style_Sheet;

   -------------------------
   -- Set_Window_Modified --
   -------------------------

   procedure Set_Window_Modified
    (Self : not null access Q_Widget'Class;
     Value : Standard.Boolean)
   is
   begin
      setWindowModified_0_wrapper
       (Self.QObject_View,
        Qt4.To_bool (Value));
   end Set_Window_Modified;

   ----------------------
   -- Set_Window_Title --
   ----------------------

   procedure Set_Window_Title
    (Self : not null access Q_Widget'Class;
     Title : Qt4.Strings.Q_String)
   is
   begin
      setWindowTitle_0_wrapper
       (Self.QObject_View,
        Qt4.Strings.Internals.QString_View (Title));
   end Set_Window_Title;

   ----------
   -- Show --
   ----------

   procedure Show
    (Self : not null access Q_Widget'Class)
   is
   begin
      show_0_wrapper
       (Self.QObject_View);
   end Show;

   ----------------------
   -- Show_Full_Screen --
   ----------------------

   procedure Show_Full_Screen
    (Self : not null access Q_Widget'Class)
   is
   begin
      showFullScreen_0_wrapper
       (Self.QObject_View);
   end Show_Full_Screen;

   --------------------
   -- Show_Maximized --
   --------------------

   procedure Show_Maximized
    (Self : not null access Q_Widget'Class)
   is
   begin
      showMaximized_0_wrapper
       (Self.QObject_View);
   end Show_Maximized;

   --------------------
   -- Show_Minimized --
   --------------------

   procedure Show_Minimized
    (Self : not null access Q_Widget'Class)
   is
   begin
      showMinimized_0_wrapper
       (Self.QObject_View);
   end Show_Minimized;

   -----------------
   -- Show_Normal --
   -----------------

   procedure Show_Normal
    (Self : not null access Q_Widget'Class)
   is
   begin
      showNormal_0_wrapper
       (Self.QObject_View);
   end Show_Normal;

   ------------
   -- Update --
   ------------

   procedure Update
    (Self : not null access Q_Widget'Class)
   is
   begin
      update_0_wrapper
       (Self.QObject_View);
   end Update;

end Qt4.Widgets;
